package org.maltparser.core.sentence;

import org.maltparser.core.exception.MaltChainedException;

/**
 *  SentenceException extends the MaltChainedException class and is thrown by classes
 *  within the sentence package.
 *
 * @author Johan Hall
 * @since 1.0
**/
public class SentenceException extends MaltChainedException {
	public static final long serialVersionUID = 8045568022124816379L; 
	/**
	 * Creates an SentenceException with a message
	 * 
	 * @param message	the message
	 */
	public SentenceException(String message) {
		super(message);
	}
	/**
	 * Creates an SentenceException with a message and a cause to the exception.
	 * 
	 * @param message	the message
	 * @param cause		the cause to the exception
	 */
	public SentenceException(String message, Throwable cause) {
		super(message, cause);
	}
}
