package org.maltparser.ml;

import java.io.BufferedWriter;
import java.util.ArrayList;

import org.maltparser.core.exception.MaltChainedException;
import org.maltparser.core.graph.DependencyGraph;
import org.maltparser.core.sentence.Sentence;
import org.maltparser.parser.guide.classtable.ClassTable;
import org.maltparser.parser.guide.feature.Feature;
import org.maltparser.parser.guide.feature.FeatureVector;


public interface LearningMethod {
	public static final int TRAIN = 0;
	public static final int CLASSIFY = 1;
	public void addInstance(ClassTable classCodeTable, FeatureVector features) throws MaltChainedException;
	public void finalizeSentence(Sentence sentence, DependencyGraph dependencyGraph)  throws MaltChainedException;
	public void noMoreInstances() throws MaltChainedException;
	public void train(FeatureVector features) throws MaltChainedException;
	public void moveAllInstances(LearningMethod method, Feature divideFeature, ArrayList<Integer> divideFeatureIndexVector) throws MaltChainedException;
	public void finalize() throws MaltChainedException;
	public boolean predict(FeatureVector features, KBestList kBestList) throws MaltChainedException;
	public BufferedWriter getInstanceWriter();
	public void increaseNumberOfInstances();
	public void decreaseNumberOfInstances();
}
