package org.maltparser.parser.guide.classtable;

import org.maltparser.core.exception.MaltChainedException;

/**
 *  ClassTableException object extends the MaltChainedException class and is thrown by classes
 *  within the classtable package.
 *
 * @author Johan Hall
 * @since 1.0
**/
public class ClassTableException extends MaltChainedException {
	public static final long serialVersionUID = 8045568022124816379L; 
	/**
	 * Creates a ClassTableException object with a message
	 * 
	 * @param message	the message
	 */
	public ClassTableException(String message) {
		super(message);
	}
	/**
	 * Creates a ClassTableException object with a message and a cause to the exception.
	 * 
	 * @param message	the message
	 * @param cause		the cause to the exception
	 */
	public ClassTableException(String message, Throwable cause) {
		super(message, cause);
	}
}

