package org.maltparser.parser.guide.feature;

import org.maltparser.core.exception.MaltChainedException;
import org.maltparser.parser.algorithm.ParsingAlgorithm;
import org.maltparser.parser.algorithm.helper.ParserAction;


/**
TODO: NB not tested yet, probably wrong behavior

@author Johan Hall
@since 1.0
 */
public final class TransitionFeature extends AtomicFeature {
	private ParserAction parserAction;
	private int index;
	private String specification;
	
	public TransitionFeature(ParsingAlgorithm parsingAlgorithm, String spec) throws MaltChainedException {
		super();
		super.initialize(parsingAlgorithm);
		spec = spec.trim();
		parserAction = parsingAlgorithm.getParserAction();
		
		if (!init(spec)) {
			throw new FeatureException("The transition feature could not be initialized at line '"+spec+"'. ");
		}
		
		updateCardinality();
	}

	public boolean init(String spec) {
		specification = spec;
		try {
			index = Integer.parseInt(spec);
			if (index < 0) {
				return false;
			}
		} catch (NumberFormatException e) {
			return false;
		}
		
		return true;
	}
	
	public void update() throws MaltChainedException {
		featureValues.clear();
		featureValues.put(parserAction.getTransition(index).getCode(), parserAction.getTransition(index).getName());
		nullValue = false;
	}
	
	public void setValue(Integer value) {
		featureValues.clear();
		featureValues.put(value, parserAction.getTransition(value));
		nullValue = false;
	}
	
	public void setValue(String value) {
		featureValues.clear();
		featureValues.put(parserAction.getTransition(value), value);
		nullValue = false;
	}
	
	public String getStringValue(Integer value) throws MaltChainedException {
		return parserAction.getTransition(value);
	}
	
	public Integer getIntegerValue(String value) throws MaltChainedException {
		return parserAction.getTransition(value);
	}
	
	public void updateCardinality() {
		super.setCardinality(parserAction.getCardinality("TRANS"));
	}
	
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!(obj instanceof TransitionFeature)) {
			return false;
		}
		return obj.toString().equals(toString());
	}
	
	public int hashCode() {
		int hash = 7;
		hash = 31 * hash + (null == toString() ? 0 : toString().hashCode());
		return hash;
	}
	
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Transition(");
		sb.append(specification);
		sb.append(')');
		return sb.toString();
	}
}
